/* 
 * This program is written by 
 *               
 *                          Murtaza Amiji
 *		Department Of ELectrical & Computer Engineering,
 *		     Worcester Polytechnic Institute,
 *		            Worcester, MA.
 *                     E-Mail: murti@ece.wpi.edu
 *               Personal Homepage: http://www.wpi.edu/~murti
 *               ECE Homepage: http://ece.wpi.edu
 *
 * Copyright (c) 1995-96 Worcester Polytechnic Institute. 
 * All rights reserved.
 * 
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for non commericial purpose, provided that 
 * the above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 * 
 * IN NO EVENT SHALL WORCESTER POLYTECHNIC INSTITUTE BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF WORCESTER 
 * POLYTECHNIC INSTITUTE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * WORCESTER POLYTECHNIC INSTITUTE SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND WORCESTER POLYTECHNIC INSTITUTE HAS NO OBLIGATION 
 * TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */


#include "ephone.h"

main()
{
  char response_buffer[1024], FLAG[40];
  struct sockaddr_in client, daemon;
  char hostname[512];
  int cli_len, daemon_len, fp = -1;
  int daemon_socket = -1;
  struct hostent *hp;

  if((daemon_socket = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    printf("Cant open datagram socket.\n");
    return (-1);
  }

  bzero((char *) &daemon, sizeof(daemon));
  daemon.sin_family = AF_INET;
  daemon.sin_addr.s_addr = htonl(INADDR_ANY);
  daemon.sin_port = htons(7000);
  daemon_len = sizeof(daemon);

  if(bind(daemon_socket, (struct sockaddr *) &daemon, daemon_len) < 0){
    perror("bind");
    return (-1);    
  }
  
  client.sin_family  = AF_INET;
  client.sin_port = htons(7000);
  cli_len = sizeof(client);
  
  
 
  for( ; ; ) {
    if(recvfrom(daemon_socket, response_buffer, 1024, 0, (struct sockaddr *) &client, &cli_len) < 0)
      printf("Error receiving response from the client.\n");  
    
    hp = gethostbyaddr((char *) &client.sin_addr, sizeof(client.sin_addr), AF_INET);
  
    if(sendto(daemon_socket, DAEMON_RESPONSE, sizeof(DAEMON_RESPONSE), 0, (struct sockaddr *) &client, cli_len) < 0)
      printf("Error responding to the client request.\n");
    while((fp = open(EPHONE_SERVER, O_WRONLY, 0)) > 0) {
      close(fp);
      printf("\n\nThe host %s is trying to contact you by E-Phone.\n", hp->h_name);
      printf("Please launch your E-Phone application.\n");
      system("cat phone.au > /dev/audio"); 
      strncpy(FLAG, "no", 16);
      if(sendto(daemon_socket, FLAG, sizeof(FLAG), 0, (struct sockaddr *) &client, cli_len) < 0){
	printf("Connection closed by client.\n");
        bzero((char *) &client, sizeof(client));
	break;
      }
      fp = -1;
      sleep(7);
    }
    strncpy(FLAG, "yes", 24);
    if(sendto(daemon_socket, FLAG, sizeof(FLAG), 0, (struct sockaddr *) &client, cli_len) < 0) {
      continue;
    }
    while((fp = open(EPHONE_SERVER, O_WRONLY, 0)) <= 0);
    close(fp);
    fp = -1;
  }
  return 0;
}








